#include "funzioni.h"

unsigned SommaCifreDec(unsigned n)
{
	unsigned sum = 0;
	while (n != 0) {
		sum += n%10;
		n /= 10;
	}
	return sum;
}

unsigned SommaCifreDecRic(unsigned n)
{
	/* pre: n >= 0 */
	/* post: SommaCifreDec(n) = SommaCifreDec($n_kn_{k-1}\ldots n_0$) = $\displaystyle\sum_{i = 0}^k n_i$ */
	if (n <= 9)
		return n;
	else /* questo else non e' necessario, perche'? */
		return n%10 + SommaCifreDecRic(n/10);
}

char Div3(unsigned n)
{
	/* pre: n >= 0 */
	/* post: Div3(n) = 1 se e solo se esiste $k \in \N$ tale che $3k = n$ */
	return n%3 == 0;
}

char Div3Ric(unsigned n)
{
	/* pre: n >= 0 */
	/* post: Div3(n) = 1 se e solo se esiste $k \in \N$ tale che $3k = n$ */
	if (n <= 9)
		return n == 0 || n == 3 || n == 6 || n == 9;
	else /* di nuovo, questo else non e' necessario */
		return Div3Ric(SommaCifreDecRic(n));
}
